local json = require('libs/lunajson/lunajson')
local Queue = require('lua/TaxiDriver/queue')
math.randomseed(os.time())

local randomCoords = {}
local currentLocation = nil

local function loadJsonFileContent(path)
	local file = io.open(path, "rb") -- r read mode and b binary mode
	local content = file:read("*a") -- *a reads the whole file
	file:close()
	
	return json.decode(content)
end

local filePoints = loadJsonFileContent('lua/TaxiDriver/coords.json')

function randomCoords.chooseRandomLocation()
  local selectedLocation = nil
  local currentVec = nil
  if currentLocation ~= nil then
    currentVec = vec3(currentLocation.point[1], currentLocation.point[2], currentLocation.point[3])
  end

  local queue = Queue:new(30)
  local attempts = 0
  while (attempts < 100)
  do
    attempts = attempts + 1

    local randomIndex = math.random(1, #filePoints.points)
    if (queue:contains(randomIndex) and attempts < 100)  then
      goto continue
    end

    queue:push(randomIndex)

    selectedLocation = filePoints.points[randomIndex]
    if currentLocation == nil then
      break
    end
    
    local selectedVec = vec3(selectedLocation.point[1], selectedLocation.point[2], selectedLocation.point[3])
    if (selectedVec:distance(currentVec) > 80 and attempts < 100) then
      break
    end
      
    ::continue::
  end
	
	currentLocation = selectedLocation
end

function randomCoords.getCurrentLocationPoint()
  if currentLocation == nil then
    return nil
  end
  
	return currentLocation.point
end

function randomCoords.getCurrentLocationRotation()
  if currentLocation == nil then
    return nil
  end
  
  return currentLocation.rotation
end

return randomCoords